scala.tools.nsc.backend.jvm.opt

# Inliner

###
Related Doc: package opt

#### class Inliner[BT <: BTypes] extends AnyRef

Source
  Inliner.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Inliner
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Inliner(btypes: BT)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Inliner[BT] to any2stringadd[Inliner[BT]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Inliner[BT], B)

   Implicit information
     This member is added by an implicit conversion from Inliner[BT] to ArrowAssoc[Inliner[BT]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### val btypes: BT

8. #### object callsiteOrdering extends Ordering[Callsite]

   Ordering for inline requests.

   Ordering for inline requests. Required to make the inliner deterministic:

   - Always remove the same request when breaking inlining cycles
   - Perform inlinings in a consistent order

9. #### def canInline(callsiteInstruction: MethodInsnNode, callsiteStackHeight: Int, callsiteMethod: MethodNode, callsiteClass: BT.ClassBType, callee: MethodNode, calleeDeclarationClass: BT.ClassBType): Option[CannotInlineWarning]

   Check whether an inling can be performed.

   Check whether an inling can be performed. Parmeters are described in method inline.

   returns

     `Some(message)` if inlining cannot be performed, `None` otherwise

10. #### def classIsAccessible(accessed: BT.BType, from: BT.ClassBType): Either[OptimizerWarning, Boolean]

    Check if a type is accessible to some class, as defined in JVMS 5.4.4.

    Check if a type is accessible to some class, as defined in JVMS 5.4.4. (A1) C is public (A2) C and D are members of the same run-time package

11. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

12. #### def doInlineCallsite(callsite: Callsite): Boolean

    The current inlining heuristics are simple: inline calls to methods annotated @inline.

13. #### def doRewriteTraitCallsite(callsite: Callsite): Boolean

    True for statically resolved trait callsites that should be rewritten to the static implementation method.

14. #### def eliminateUnreachableCodeAndUpdateCallGraph(methodNode: MethodNode, definingClass: InternalName): Unit

15. #### def ensuring(cond: (Inliner[BT]) ⇒ Boolean, msg: ⇒ Any): Inliner[BT]

    Implicit information
      This member is added by an implicit conversion from Inliner[BT] to Ensuring[Inliner[BT]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (Inliner[BT]) ⇒ Boolean): Inliner[BT]

    Implicit information
      This member is added by an implicit conversion from Inliner[BT] to Ensuring[Inliner[BT]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): Inliner[BT]

    Implicit information
      This member is added by an implicit conversion from Inliner[BT] to Ensuring[Inliner[BT]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): Inliner[BT]

    Implicit information
      This member is added by an implicit conversion from Inliner[BT] to Ensuring[Inliner[BT]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

21. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

22. #### def findIllegalAccess(instructions: InsnList, calleeDeclarationClass: BT.ClassBType, destinationClass: BT.ClassBType): Option[(AbstractInsnNode, Option[OptimizerWarning])]

    Returns the first instruction in the `instructions` list that would cause a java.lang.IllegalAccessError when inlined into the `destinationClass`.

    Returns the first instruction in the `instructions` list that would cause a java.lang.IllegalAccessError when inlined into the `destinationClass`.

    If validity of some instruction could not be checked because an error occurred, the instruction is returned together with a warning message that describes the problem.

23. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Inliner[BT] to StringFormat[Inliner[BT]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

24. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

25. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

26. #### def inline(callsiteInstruction: MethodInsnNode, callsiteStackHeight: Int, callsiteMethod: MethodNode, callsiteClass: BT.ClassBType, callee: MethodNode, calleeDeclarationClass: BT.ClassBType, receiverKnownNotNull: Boolean, keepLineNumbers: Boolean): Option[CannotInlineWarning]

    Copy and adapt the instructions of a method to a callsite.

    Copy and adapt the instructions of a method to a callsite.

    Preconditions:

    - The maxLocals and maxStack values of the callsite method are correctly computed
    - The callsite method contains no unreachable basic blocks, i.e., running an Analyzer does not produce any `null` frames
    callsiteInstruction

      The invocation instruction

    callsiteStackHeight

      The stack height at the callsite

    callsiteMethod

      The method in which the invocation occurs

    callsiteClass

      The class in which the callsite method is defined

    callee

      The invoked method

    calleeDeclarationClass

      The class in which the invoked method is defined

    receiverKnownNotNull

      `true` if the receiver is known to be non-null

    keepLineNumbers

      `true` if LineNumberNodes should be copied to the call site

    returns

      `Some(message)` if inlining cannot be performed, `None` otherwise

27. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

28. #### def memberIsAccessible(memberFlags: Int, memberDeclClass: BT.ClassBType, memberRefClass: BT.ClassBType, from: BT.ClassBType): Either[OptimizerWarning, Boolean]

    Check if a member reference is accessible from the destinationClass, as defined in the JVMS 5.4.4.

    Check if a member reference is accessible from the destinationClass, as defined in the JVMS 5.4.4. Note that the class name in a field / method reference is not necessarily the class in which the member is declared:

    class A { def f = 0 }; class B extends A { f }

    The INVOKEVIRTUAL instruction uses a method reference "B.f ()I". Therefore this method has two parameters:

    memberDeclClass

      The class in which the member is declared (A)

    memberRefClass

      The class used in the member reference (B) (B0) JVMS 5.4.3.2 / 5.4.3.3: when resolving a member of class C in D, the class C is resolved first. According to 5.4.3.1, this requires C to be accessible in D. JVMS 5.4.4 summary: A field or method R is accessible to a class D (destinationClass) iff (B1) R is public (B2) R is protected, declared in C (memberDeclClass) and D is a subclass of C. If R is not static, R must contain a symbolic reference to a class T (memberRefClass), such that T is either a subclass of D, a superclass of D, or D itself. Also (P) needs to be satisfied. (B3) R is either protected or has default access and declared by a class in the same run-time package as D. If R is protected, also (P) needs to be satisfied. (B4) R is private and is declared in D. (P) When accessing a protected instance member, the target object on the stack (the receiver) has to be a subtype of D (destinationClass). This is enforced by classfile verification (https://docs.oracle.com/javase/specs/jvms/se8/html/jvms-4.html#jvms-4.10.1.8). TODO: we cannot currently implement (P) because we don't have the necessary information available. Once we have a type propagation analysis implemented, we can extract the receiver type from there (https://github.com/scala-opt/scala/issues/13).

29. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

30. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

31. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

32. #### def rewriteFinalTraitMethodInvocation(callsite: Callsite): Unit

    Rewrite the INVOKEINTERFACE callsite of a final trait method invocation to INVOKESTATIC of the corresponding method in the implementation class.

    Rewrite the INVOKEINTERFACE callsite of a final trait method invocation to INVOKESTATIC of the corresponding method in the implementation class. This enables inlining final trait methods.

    In a final trait method callsite, the callee is safeToInline and the callee method is abstract (the receiver type is the interface, so the method is abstract).

33. #### def rewriteFinalTraitMethodInvocations(): Unit

34. #### def runInliner(): Unit

35. #### def selectCallsitesForInlining: List[Callsite]

    Select callsites from the call graph that should be inlined.

    Select callsites from the call graph that should be inlined. The resulting list of inlining requests is allowed to have cycles, and the callsites can appear in any order.

36. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

37. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

38. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### def →[B](y: B): (Inliner[BT], B)

    Implicit information
      This member is added by an implicit conversion from Inliner[BT] to ArrowAssoc[Inliner[BT]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Inliner[BT] to any2stringadd[Inliner[BT]]

### Inherited by implicit conversion StringFormat from Inliner[BT] to StringFormat[Inliner[BT]]

### Inherited by implicit conversion Ensuring from Inliner[BT] to Ensuring[Inliner[BT]]

### Inherited by implicit conversion ArrowAssoc from Inliner[BT] to ArrowAssoc[Inliner[BT]]

### Ungrouped